import { Deferred } from "./Deferred";

interface DeferredList<T> extends Deferred<T[]> {
    /**
     * Gathers the results of the deferreds for packaging
     * as the parameters to the Deferred Lists' callback
     */
    gatherResults<T>(deferredList: DeferredList<any>): DeferredList<T>;
}

interface DeferredListConstructor {
    /**
     * Deprecated, use dojo/promise/all instead.
     * Provides event handling for a group of Deferred objects.
     */
    new <T>(list: T[], fireOnOneCallback?: boolean, fireOnOneErrback?: boolean, consumeErrors?: boolean, canceller?: (reason: any) => void): DeferredList<T>;
    prototype: DeferredList<any>;
}